"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  ImageType: () => ImageType,
  SortOrder: () => SortOrder,
  SyncStatus: () => SyncStatus,
  WebhookIdentityType: () => WebhookIdentityType,
  onProjectInCollectionProjectOrderInCollectionUpdatedEvent: () => onProjectInCollectionProjectOrderInCollectionUpdatedEvent2,
  updateProjectOrderInCollection: () => updateProjectOrderInCollection4
});
module.exports = __toCommonJS(index_exports);

// src/portfolio-projects-v1-project-in-collection-project-in-collections.public.ts
var import_rename_all_nested_keys2 = require("@wix/sdk-runtime/rename-all-nested-keys");
var import_float3 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths3 = require("@wix/sdk-runtime/transformations/transform-paths");
var import_sdk_types = require("@wix/sdk-types");

// src/portfolio-projects-v1-project-in-collection-project-in-collections.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/portfolio-projects-v1-project-in-collection-project-in-collections.http.ts
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressPortfolioProjectsProjectInCollectionsServiceUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      },
      {
        srcPath: "/portfolio/projects/projects/api/v1/bulk/portfolio/projects",
        destPath: "/api/v1/bulk/portfolio/projects"
      },
      {
        srcPath: "/portfolio/projects/projects/api/1/portfolio/projects",
        destPath: "/api/1/portfolio/projects"
      }
    ],
    _: [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      },
      {
        srcPath: "/portfolio/projects/projects/api/v1/bulk/portfolio/projects",
        destPath: "/api/v1/bulk/portfolio/projects"
      },
      {
        srcPath: "/portfolio/projects/projects/api/1/portfolio/projects",
        destPath: "/api/1/portfolio/projects"
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/projects-service",
        destPath: "/api"
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/portfolio/v1/projects",
        destPath: "/api/v1/portfolio/projects"
      },
      {
        srcPath: "/portfolio/projects/projects/api/v1/bulk/portfolio/projects",
        destPath: "/api/v1/bulk/portfolio/projects"
      },
      {
        srcPath: "/portfolio/projects/projects/api/v1/portfolio/projects",
        destPath: "/api/v1/portfolio/projects"
      },
      {
        srcPath: "/portfolio/projects/projects/api/1/portfolio/projects",
        destPath: "/api/1/portfolio/projects"
      }
    ],
    "api._api_base_domain_": [
      {
        srcPath: "/projects-service",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_portfolio_project-in-collections";
function updateProjectOrderInCollection(payload) {
  function __updateProjectOrderInCollection({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [{ path: "sortOrder" }]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.portfolio.projects.v1.project_in_collection",
      method: "PATCH",
      methodFqn: "com.wixpress.portfolio.projects.ProjectInCollectionsService.UpdateProjectOrderInCollection",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressPortfolioProjectsProjectInCollectionsServiceUrl({
        protoPath: "/api/v1/portfolio/projects/{projectId}/collections/{collectionId}/order",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "project.sortOrder" },
            { path: "projectInCollection.sortOrder" },
            { path: "project.project.coverImage.focalPoint.x" },
            { path: "project.project.coverImage.focalPoint.y" },
            { path: "projectInCollection.project.coverImage.focalPoint.x" },
            { path: "projectInCollection.project.coverImage.focalPoint.y" },
            { path: "project.project.coverImage.unsharpMasking.amount" },
            { path: "project.project.coverImage.unsharpMasking.radius" },
            { path: "project.project.coverImage.unsharpMasking.threshold" },
            {
              path: "projectInCollection.project.coverImage.unsharpMasking.amount"
            },
            {
              path: "projectInCollection.project.coverImage.unsharpMasking.radius"
            },
            {
              path: "projectInCollection.project.coverImage.unsharpMasking.threshold"
            }
          ]
        },
        {
          transformFn: import_timestamp.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "project.project.createdDate" },
            { path: "project.project.updatedDate" },
            {
              path: "project.project.coverImage.imageInfo.urlExpirationDate"
            },
            {
              path: "project.project.coverVideo.videoInfo.urlExpirationDate"
            },
            {
              path: "project.project.coverVideo.videoInfo.resolutions.poster.urlExpirationDate"
            },
            {
              path: "project.project.coverVideo.videoInfo.posters.urlExpirationDate"
            },
            { path: "project.project.source.lastSync" },
            { path: "projectInCollection.project.createdDate" },
            { path: "projectInCollection.project.updatedDate" },
            {
              path: "projectInCollection.project.coverImage.imageInfo.urlExpirationDate"
            },
            {
              path: "projectInCollection.project.coverVideo.videoInfo.urlExpirationDate"
            },
            {
              path: "projectInCollection.project.coverVideo.videoInfo.resolutions.poster.urlExpirationDate"
            },
            {
              path: "projectInCollection.project.coverVideo.videoInfo.posters.urlExpirationDate"
            },
            { path: "projectInCollection.project.source.lastSync" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateProjectOrderInCollection;
}

// src/portfolio-projects-v1-project-in-collection-project-in-collections.universal.ts
var import_image = require("@wix/sdk-runtime/transformations/image");
var import_video_v2 = require("@wix/sdk-runtime/transformations/video-v2");
var import_page_url_v2 = require("@wix/sdk-runtime/transformations/page-url-v2");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var ImageType = /* @__PURE__ */ ((ImageType2) => {
  ImageType2["UNDEFINED"] = "UNDEFINED";
  ImageType2["WIX_MEDIA"] = "WIX_MEDIA";
  ImageType2["EXTERNAL"] = "EXTERNAL";
  return ImageType2;
})(ImageType || {});
var SyncStatus = /* @__PURE__ */ ((SyncStatus2) => {
  SyncStatus2["SYNCED"] = "SYNCED";
  SyncStatus2["SYNCING"] = "SYNCING";
  SyncStatus2["NOT_SYNCED"] = "NOT_SYNCED";
  return SyncStatus2;
})(SyncStatus || {});
var SortOrder = /* @__PURE__ */ ((SortOrder2) => {
  SortOrder2["ASC"] = "ASC";
  SortOrder2["DESC"] = "DESC";
  return SortOrder2;
})(SortOrder || {});
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
async function updateProjectOrderInCollection2(identifiers, sortOrder) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    projectId: identifiers?.projectId,
    collectionId: identifiers?.collectionId,
    sortOrder
  });
  const reqOpts = updateProjectOrderInCollection(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_page_url_v2.transformRESTPageURLV2ToSDKPageURLV2,
          paths: [
            { path: "project.project.url" },
            { path: "projectInCollection.project.url" }
          ]
        },
        {
          transformFn: import_image.transformRESTImageToSDKImage,
          paths: [
            { path: "project.project.coverImage.imageInfo" },
            { path: "projectInCollection.project.coverImage.imageInfo" }
          ]
        },
        {
          transformFn: import_video_v2.transformRESTVideoV2ToSDKVideoV2,
          paths: [
            { path: "project.project.coverVideo.videoInfo" },
            { path: "projectInCollection.project.coverVideo.videoInfo" }
          ]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          projectId: "$[0].projectId",
          collectionId: "$[0].collectionId",
          sortOrder: "$[1]"
        },
        singleArgumentUnchanged: false
      },
      ["identifiers", "sortOrder"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/portfolio-projects-v1-project-in-collection-project-in-collections.public.ts
function updateProjectOrderInCollection3(httpClient) {
  return (identifiers, sortOrder) => updateProjectOrderInCollection2(
    identifiers,
    sortOrder,
    // @ts-ignore
    { httpClient }
  );
}
var onProjectInCollectionProjectOrderInCollectionUpdatedEvent = (0, import_sdk_types.EventDefinition)(
  "wix.portfolio.projects.v1.project_in_collection_project_order_in_collection_updated_event",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_float3.transformRESTFloatToSDKFloat,
        paths: [{ path: "data.sortOrder" }]
      },
      {
        transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: "metadata.eventTime" }]
      }
    ])
  )
)();

// src/portfolio-projects-v1-project-in-collection-project-in-collections.context.ts
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
var import_event_definition_modules = require("@wix/sdk-runtime/event-definition-modules");
var updateProjectOrderInCollection4 = /* @__PURE__ */ (0, import_rest_modules2.createRESTModule)(updateProjectOrderInCollection3);
var onProjectInCollectionProjectOrderInCollectionUpdatedEvent2 = (0, import_event_definition_modules.createEventModule)(
  onProjectInCollectionProjectOrderInCollectionUpdatedEvent
);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ImageType,
  SortOrder,
  SyncStatus,
  WebhookIdentityType,
  onProjectInCollectionProjectOrderInCollectionUpdatedEvent,
  updateProjectOrderInCollection
});
//# sourceMappingURL=index.js.map